# -*- coding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2011 Tecnoba S.L. (http://www.tecnoba.com)
#      Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school module
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program. If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _


class course_modify_min_hours(osv.osv_memory):
    _name = 'school.course.modify_min_hours'

    _columns = {
        'course_ids' : fields.many2many('school.course', 'school_course_mmh_wizard_rel', 'mmhw_id','course_id',string='Courses',required=True,),
        'min_hours' : fields.integer('Min hours', required=True,),
    }

    _defaults = {
        'course_ids' : lambda self,cr,uid,context={}: context.get('active_ids',[]),
        'min_hours' : lambda *a : 1,
    }

    def _check_min_hours(self, cr, uid, ids, context=None):
        return [ x for x in self.browse(cr, uid, ids, context=context) if x.min_hours > 0 ]

    def action_cancel(self, cr, uid, ids, context=None):
        return {'type': 'ir.actions.act_window_close'}

    def action_apply(self, cr, uid, ids, context=None):
        if context is None: context={}
        for item in self.browse(cr, uid, ids, context=context):
            self.pool.get('school.course').write(cr, uid, [x.id for x in item.course_ids], {'min_hours': item.min_hours}, context=context)
        return {'type': 'ir.actions.act_window_close'}

    _constraints = [(_check_min_hours, _("Min. Hours must be greater than zero"), ['min_hours']),]

course_modify_min_hours()
